import 'dart:ffi';

import 'package:ffi/ffi.dart';

///libjerryscriptwrapper.so
DynamicLibrary libjsw = DynamicLibrary.open("/home/anurag/ws/jsengine/jerryscriptwrapper/build/libjerryscriptwrapper.so");

///void runJS(char * program, char* result)
typedef _runJS_sign = Void Function(Pointer<Utf8> program, Pointer<Utf8> result);
typedef _runJS_func = void Function(Pointer<Utf8> program, Pointer<Utf8> result);
final _runJS_func runJS_native = libjsw.lookup<NativeFunction<_runJS_sign>>("runJS").asFunction();
String runJS(String program){
  String result;
  Pointer<Utf8> resultPtr = Utf8.toUtf8(result);
  Pointer<Utf8> programPtr = Utf8.toUtf8(program);
  runJS_native(programPtr, resultPtr);
  return Utf8.fromUtf8(resultPtr);
}

///Jerry engine initialization
///
///void jerry_init (jerry_init_flag_t flags)
typedef _jerry_init_sign = Void Function(Int32 flags);
typedef _jerry_init_func = void Function(int);
final _jerry_init_func jerry_init = libjsw.lookup<NativeFunction<_jerry_init_sign>>("jerry_init").asFunction();

///Terminate Jerry engine
///
///void jerry_cleanup (void)
typedef _jerry_cleanup_sign = Void Function(Void);
typedef _jerry_cleanup_func = void Function(void);
final _jerry_cleanup_func jerry_cleanup = libjsw.lookup<NativeFunction<_jerry_cleanup_sign>>("jerry_cleanup").asFunction();

///Release specified Jerry API value
///
///void jerry_release_value (jerry_value_t value)
typedef _jerry_release_value_sign = Void Function(Int32 value);
typedef _jerry_release_value_func = void Function(int value);
final _jerry_release_value_func jerry_release_value = libjsw.lookup<NativeFunction<_jerry_release_value_sign>>("jerry_release_value").asFunction();


///check if jerryr value is of some type
typedef _jerry_value_is_sign = Int8 Function(Int32 value);
typedef _jerry_value_is_func = int Function(int value);

final _jerry_value_is_func jerry_value_is_error = libjsw.lookup<NativeFunction<_jerry_value_is_sign>>("jerry_value_is_error").asFunction();
final _jerry_value_is_func jerry_value_is_string = libjsw.lookup<NativeFunction<_jerry_value_is_sign>>("jerry_value_is_string").asFunction();
final _jerry_value_is_func jerry_value_is_number = libjsw.lookup<NativeFunction<_jerry_value_is_sign>>("jerry_value_is_number").asFunction();
final _jerry_value_is_func jerry_value_is_null = libjsw.lookup<NativeFunction<_jerry_value_is_sign>>("jerry_value_is_null").asFunction();
final _jerry_value_is_func jerry_value_is_bool = libjsw.lookup<NativeFunction<_jerry_value_is_sign>>("jerry_value_is_boolean").asFunction();
final _jerry_value_is_func jerry_value_is_array = libjsw.lookup<NativeFunction<_jerry_value_is_sign>>("jerry_value_is_array").asFunction();

///Convert jerry value to String
///
///char* giveMeStringFromJerryValue(jerry_value_t value){
typedef _giveMeStringFromJerryValue_sign = Pointer<Utf8> Function(Int32 value);
typedef _giveMeStringFromJerryValue_func = Pointer<Utf8> Function(int value);
final _giveMeStringFromJerryValue_func giveMeStringFromJerryValue_native = libjsw.lookup<NativeFunction<_giveMeStringFromJerryValue_sign>>("giveMeStringFromJerryValue").asFunction();
String giveMeStringFromJerryValue(int value){
  Pointer<Utf8>  t1 = giveMeStringFromJerryValue_native(value);
  return Utf8.fromUtf8(t1);
}

///
///Perform eval
///
///Note: returned value must be freed with jerry_release_value, when it is no longer needed.
///
///@return result of eval, may be error value.
///
/// jerry_value_t jerry_eval (const jerry_char_t *source_p, /**< source code */ size_t source_size, /**< length of source code */    uint32_t parse_opts)
typedef _jerry_eval_sign = Int32 Function(Pointer<Utf8> source_p,Int32 source_size, Int32 parse_opts);
typedef _jerry_eval_func = int Function(Pointer<Utf8> source, int source_size, int parse_ops);
final _jerry_eval_func jerry_eval_native = libjsw.lookup<NativeFunction<_jerry_eval_sign>>("jerry_eval").asFunction();
String jerry_eval(String source){
  int source_size = source.length;
  int parse_opts = 0; //1 for JERRY_PARSE_NO_OPTS=0, JERRY_PARSE_STRICT_MODE= (1 << 0)
  Pointer<Utf8> source_pointer = Utf8.toUtf8(source);
  return giveMeStringFromJerryValue(jerry_eval_native(source_pointer, source_size, parse_opts));
}

