import 'dart:ffi';

import 'package:ffi/ffi.dart';
import 'package:jsengine/src/otherlibsextensions.dart';

typedef _runJSCode = Pointer<Utf8> Function(Pointer<Utf8> program);

class JSEngine{
  final String pathToLibSoFile;
  DynamicLibrary libjsw;
  _runJSCode _runJSCodeNative;

  JSEngine({this.pathToLibSoFile= "libjerryscriptwrapper.so"}){
    libjsw = DynamicLibrary.open(pathToLibSoFile);
    _runJSCodeNative = libjsw.lookup<NativeFunction<_runJSCode>>("runJSCode").asFunction();
  }

  String runJSCode(String jscode){
    Pointer<Utf8> programPtr = Utf8.toUtf8(jscode);
    Pointer<Utf8> resultPtr = _runJSCodeNative(programPtr);
    return ExtUtf8.fromUtf8(resultPtr);
  }

}





